## ompl 1.0.0+ds2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
if(NOT ${CMAKE_VERSION} VERSION_LESS 3.0.0)
    cmake_policy(SET CMP0042 OLD)
endif()
project(ompl CXX C)

# set the default build type
if (NOT CMAKE_BUILD_TYPE)
    # By default, use Release mode
    set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Type of build" FORCE)

    # On 32bit architectures, use RelWithDebInfo
    if (CMAKE_COMPILER_IS_GNUCC AND CMAKE_SIZEOF_VOID_P EQUAL 4)
        set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "Type of build" FORCE)
    endif()
endif()

message(STATUS "Building ${CMAKE_BUILD_TYPE}")

# This shouldn't be necessary, but there has been trouble
# with MSVC being set off, but MSVCXX ON.
if(MSVC OR MSVC90 OR MSVC10)
    set(MSVC ON)
endif (MSVC OR MSVC90 OR MSVC10)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules")
include(GNUInstallDirs)
include(CompilerSettings)
include(OMPLVersion)
include(OMPLUtils)

set(EXECUTABLE_OUTPUT_PATH "${PROJECT_BINARY_DIR}/bin")
set(LIBRARY_OUTPUT_PATH "${PROJECT_BINARY_DIR}/lib")

set(OMPL_CMAKE_UTIL_DIR "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules"
    CACHE FILEPATH "Path to directory with auxiliary CMake scripts for OMPL")
set(OMPL_INCLUDE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/src")
set(OMPL_DEMO_INSTALL_DIR "share/ompl${OMPL_INSTALL_SUFFIX}/demos"
    CACHE STRING "Relative path to directory where demos will be installed")

include_directories("${OMPL_INCLUDE_DIR}")


if(MSVC)
    add_definitions(-DBOOST_ALL_NO_LIB)
    add_definitions(-DBOOST_PROGRAM_OPTIONS_DYN_LINK)
endif(MSVC)
if(IS_ICPC)
    set(Boost_USE_STATIC_LIBS ON CACHE STRING "Use statically linked Boost libraries")
else(IS_ICPC)
    # Ensure dynamic linking with boost unit_test_framework
    add_definitions(-DBOOST_TEST_DYN_LINK)
endif(IS_ICPC)

# Do one quiet find_package on Boost to see if it is recent enough to
# have the try_join_for call
find_package(Boost QUIET 1.50)

# If Boost is not found at all, the check for version 1.50 below will die in
# the most ungraceful manner because Boost_VERSION is not defined.  Define the
# variable here for a more useful error.
if (NOT ${Boost_FOUND})
    set(Boost_VERSION 0)
endif()

# try_join_for requires the chrono library, so if we will use
# try_join_for, we need to include the chrono component
# Must recheck the Boost version, since update_bindings will re-run CMake
# and this will pass for versions of Boost < 1.50
if (${Boost_FOUND} AND ${Boost_VERSION} GREATER 104900) # Boost version is at least 1.50
  # we're using chrono
  find_package(Boost COMPONENTS date_time thread serialization filesystem system program_options unit_test_framework chrono REQUIRED)
else()
  # don't use chrono
  find_package(Boost COMPONENTS date_time thread serialization filesystem system program_options unit_test_framework REQUIRED)
endif()
include_directories(SYSTEM ${Boost_INCLUDE_DIR})

if(${Boost_VERSION} LESS 105300)
  # Include bundled version of boost::odeint if it isn't installed natively
  set(ODEINT_INCLUDE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/src/external")
  include_directories(SYSTEM "${ODEINT_INCLUDE_DIR}")
endif()

# on OS X we need to check whether to use libc++ or libstdc++ with clang++
if(APPLE AND CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    include(GetPrerequisites)
    get_prerequisites("${Boost_SYSTEM_LIBRARY}" _libs 0 0 "/" "")
    set(CXXSTDLIB "")
    foreach(_lib ${_libs})
        if(_lib MATCHES "libc\\+\\+")
            set(CXXSTDLIB "libc++")
        elseif(_lib MATCHES "libstdc\\+\\+")
            set(CXXSTDLIB "libstdc++")
        endif()
    endforeach()
    if(CXXSTDLIB)
        add_definitions(-stdlib=${CXXSTDLIB})
    endif()
endif()


# pthread is sometimes needed, depending on OS / compiler
find_package(Threads QUIET)

enable_testing()

find_package(Python QUIET)
find_package(Boost COMPONENTS python QUIET)

# MORSE is only needed for Modular OpenRobots Simulation Engine bindings
find_package(MORSE QUIET)
set(OMPL_EXTENSION_MORSE ${MORSE_FOUND})

# OpenDE is only needed for Open Dynamics Engine bindings
find_package(OpenDE QUIET)
set(OMPL_EXTENSION_OPENDE ${OPENDE_FOUND})
if (OPENDE_FOUND)
  add_definitions(${OPENDE_DEFINITIONS})
  include_directories(SYSTEM ${OPENDE_INCLUDE_DIR})
endif()

find_package(Triangle QUIET)
set(OMPL_EXTENSION_TRIANGLE ${TRIANGLE_FOUND})
if (TRIANGLE_FOUND)
  include_directories(SYSTEM ${TRIANGLE_INCLUDE_DIR})
endif()

# If FLANN is installed, a wrapper for its nearest neighbor data structures can be used
find_package(flann 1.8.3 QUIET)
if (FLANN_FOUND)
    set(OMPL_HAVE_FLANN 1)
    include_directories(SYSTEM "${FLANN_INCLUDE_DIRS}")
endif()

option(OMPL_LOCAL_PYPLUSPLUS_INSTALL "Whether Py++ and dependencies should be installed in the build directory" OFF)
set(SUDO "sudo")
set(CMAKE_GCCXML_ARGS "")
if(OMPL_LOCAL_PYPLUSPLUS_INSTALL)
    set(SUDO "")
    set(CMAKE_GCCXML_ARGS "-DCMAKE_INSTALL_PREFIX=${PROJECT_BINARY_DIR}/pyplusplus")
    set(DISTUTILS_ARGS "--prefix=${PROJECT_BINARY_DIR}/pyplusplus")
endif()

add_subdirectory(py-bindings)
add_subdirectory(src)
add_subdirectory(tests)
add_subdirectory(demos)
add_subdirectory(scripts)
add_subdirectory(doc)

if (NOT MSVC)
  set(PKG_NAME "ompl")
  set(PKG_DESC "The Open Motion Planning Library")
  set(PKG_OMPL_LIBS "-lompl")
  set(pkg_conf_file "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules/ompl.pc")
  configure_file("${pkg_conf_file}.in" "${pkg_conf_file}" @ONLY)
  install(FILES "${pkg_conf_file}"
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig/
    COMPONENT ompl
    RENAME "ompl${OMPL_INSTALL_SUFFIX}.pc")

  install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/doc/markdown/FindOMPL.cmake"
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/ompl${OMPL_INSTALL_SUFFIX}"
    COMPONENT ompl
    RENAME ompl-config.cmake)
endif()

# uninstall target
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)
add_custom_target(uninstall
  COMMAND ${CMAKE_COMMAND} -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

if (OMPL_VERSIONED_INSTALL)
  # script to create sym links
  configure_file("${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules/create_symlinks.sh.in"
    "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules/create_symlinks.sh" @ONLY)
  execute_process(COMMAND
    "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules/create_symlinks.sh"
    WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")
  install(DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/.symlinks/" DESTINATION .)
  # script to uninstall sym links
  configure_file("${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules/uninstall_symlinks.sh.in"
    "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules/uninstall_symlinks.sh" @ONLY)
  add_custom_target(uninstall_links COMMAND
    "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules/uninstall_symlinks.sh")
  add_dependencies(uninstall uninstall_links)
endif()
include(CPackSettings)

option(OMPL_REGISTRATION "Enable one-time registration of OMPL" ON)
if (OMPL_REGISTRATION)
    find_file(OMPL_REGISTERED ".registered" PATHS "${CMAKE_CURRENT_SOURCE_DIR}" NO_DEFAULT_PATH)
    if (NOT OMPL_REGISTERED)
        file(WRITE "${CMAKE_CURRENT_SOURCE_DIR}/.registered" "")
        find_package(Python QUIET)
        if (PYTHON_FOUND)
            execute_process(COMMAND "${PYTHON_EXEC}" "-m" "webbrowser" "http://ompl.kavrakilab.org/core/register.html"
                OUTPUT_QUIET ERROR_QUIET)
        endif()
    endif()
endif()

=== demos/CMakeLists.txt ===
option(OMPL_BUILD_DEMOS "Build OMPL demos" ON)

if (OMPL_BUILD_DEMOS)

  macro(add_ompl_demo demo_name)
    add_executable(${ARGV})
    target_link_libraries(${demo_name}
      ompl
      ${Boost_FILESYSTEM_LIBRARY}
      ${Boost_SYSTEM_LIBRARY}
      ${Boost_THREAD_LIBRARY}
      ${Boost_DATE_TIME_LIBRARY}
      ${Boost_PROGRAM_OPTIONS_LIBRARY})
  endmacro(add_ompl_demo)

  add_ompl_demo(demo_RigidBodyPlanning RigidBodyPlanning.cpp)
  add_ompl_demo(demo_RigidBodyPlanningWithIK RigidBodyPlanningWithIK.cpp)
  add_ompl_demo(demo_RigidBodyPlanningWithControls RigidBodyPlanningWithControls.cpp)
  add_ompl_demo(demo_RigidBodyPlanningWithIntegrationAndControls RigidBodyPlanningWithIntegrationAndControls.cpp)
  add_ompl_demo(demo_RigidBodyPlanningWithODESolverAndControls RigidBodyPlanningWithODESolverAndControls.cpp)
  add_ompl_demo(demo_StateSampling StateSampling.cpp)
  add_ompl_demo(demo_GeometricCarPlanning GeometricCarPlanning.cpp)
  add_ompl_demo(demo_Point2DPlanning Point2DPlanning.cpp)
  add_ompl_demo(demo_HybridSystemPlanning HybridSystemPlanning.cpp)
  add_ompl_demo(demo_KinematicChainBenchmark KinematicChainBenchmark.cpp)
  add_ompl_demo(demo_HypercubeBenchmark HypercubeBenchmark.cpp)
  aux_source_directory(Koules Koules_SRC)
  add_ompl_demo(demo_Koules ${Koules_SRC})
  add_ompl_demo(demo_PlannerData PlannerData.cpp)

  add_ompl_demo(demo_OptimalPlanning OptimalPlanning.cpp)
  add_ompl_demo(demo_PlannerProgressProperties PlannerProgressProperties.cpp)
  add_ompl_demo(demo_CForestCircleGridBenchmark CForestCircleGridBenchmark.cpp)

  if (OMPL_EXTENSION_OPENDE)
    add_ompl_demo(demo_OpenDERigidBodyPlanning OpenDERigidBodyPlanning.cpp)
  endif()

  if (OMPL_EXTENSION_TRIANGLE)
    add_ompl_demo(demo_TriangulationDemo TriangulationDemo.cpp)
    add_ompl_demo(demo_LTLWithTriangulation LTLWithTriangulation)
  endif()


endif(OMPL_BUILD_DEMOS)

file(GLOB OMPL_DEMO_CXX_FILES "*.cpp")
file(GLOB OMPL_DEMO_PY_FILES "*.py")
install(FILES ${OMPL_DEMO_CXX_FILES} ${OMPL_DEMO_PY_FILES}
    DESTINATION "${OMPL_DEMO_INSTALL_DIR}"
    COMPONENT ompl)
install(DIRECTORY Koules
    DESTINATION "${OMPL_DEMO_INSTALL_DIR}"
    COMPONENT ompl)

=== doc/CMakeLists.txt ===
find_package(Doxygen QUIET)

if(DOXYGEN)
    if(UNIX)
        execute_process(COMMAND date "+%b %d, %Y"
            OUTPUT_VARIABLE OMPL_RELEASE_DATE
            OUTPUT_STRIP_TRAILING_WHITESPACE)
        set(OMPL_RELEASE_DATE "${OMPL_RELEASE_DATE}" PARENT_SCOPE)
    endif()
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/header.html.in"
        "${CMAKE_CURRENT_SOURCE_DIR}/header.html")
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/markdown/download.md.in"
        "${CMAKE_CURRENT_SOURCE_DIR}/markdown/download.md")
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/markdown/mainpage.md.in"
        "${CMAKE_CURRENT_SOURCE_DIR}/markdown/mainpage.md")
    file(READ "${CMAKE_CURRENT_SOURCE_DIR}/images/ompl.svg" OMPLSVG)
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/markdown/api_overview.md.in"
        "${CMAKE_CURRENT_SOURCE_DIR}/markdown/api_overview.md")

    # add "doc" target if Doxygen is detected
    add_custom_target(doc
        COMMAND ./mkdocs.sh
        WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/doc")

    # add "website" target
    add_custom_target(website
        COMMAND ./mkwebdocs.sh
        DEPENDS doc
        WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/doc")
endif(DOXYGEN)

install(FILES man/ompl_benchmark_statistics.1
    DESTINATION ${CMAKE_INSTALL_MANDIR}/man1 COMPONENT ompl)

=== tests/CMakeLists.txt ===
# configure location of resources
file(TO_NATIVE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/resources" TEST_RESOURCES_DIR)
if(WIN32)
    # Correct directory separator for Windows
    string(REPLACE "\\" "\\\\" TEST_RESOURCES_DIR "${TEST_RESOURCES_DIR}")
endif(WIN32)
configure_file("${TEST_RESOURCES_DIR}/config.h.in" "${TEST_RESOURCES_DIR}/config.h")

# Disable teamcity reporting for tests by default
option(OMPL_TESTS_TEAMCITY "Enable unit test reporting to TeamCity" OFF)
file(TO_NATIVE_PATH "${CMAKE_CURRENT_SOURCE_DIR}" CURRENT_DIR)
configure_file("${CURRENT_DIR}/BoostTestTeamCityReporter.h.in" "${CURRENT_DIR}/BoostTestTeamCityReporter.h")

# Test datastructures implementation
add_ompl_test(test_heap datastructures/heap.cpp)
add_ompl_test(test_grid datastructures/grid.cpp)
add_ompl_test(test_gridb datastructures/gridb.cpp)
add_ompl_test(test_nearestneighbors datastructures/nearestneighbors.cpp)
add_ompl_test(test_pdf datastructures/pdf.cpp)

# Test utilities
add_ompl_test(test_random util/random/random.cpp)
add_ompl_test(test_machine_specs benchmark/machine_specs.cpp)

# Test base code
add_ompl_test(test_state_operations base/state_operations.cpp)
add_ompl_test(test_state_spaces base/state_spaces.cpp)
add_ompl_test(test_state_storage base/state_storage.cpp)
add_ompl_test(test_ptc base/ptc.cpp)
add_ompl_test(test_planner_data base/planner_data.cpp)

# Test kinematic motion planners in 2D environments
add_ompl_test(test_2denvs_geometric geometric/2d/2denvs.cpp)
add_ompl_test(test_2dmap_geometric_simple geometric/2d/2dmap_simple.cpp)
add_ompl_test(test_2dmap_ik geometric/2d/2dmap_ik.cpp)
add_ompl_test(test_2dcircles_opt_geometric geometric/2d/2dcircles_optimize.cpp)

# Test planning with controls on a 2D map
add_ompl_test(test_2dmap_control control/2dmap/2dmap.cpp)
add_ompl_test(test_planner_data_control control/planner_data.cpp)

# Test planning via MORSE extension
if(OMPL_EXTENSION_MORSE)
    add_ompl_test(test_morse_extension extensions/morse/morse_plan.cpp)
endif(OMPL_EXTENSION_MORSE)

# Python unit tests
if(PYTHON_FOUND AND OMPL_BUILD_PYTESTS AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../py-bindings/bindings")
    add_ompl_python_test(util/test_util.py)
    add_ompl_python_test(base/test_base.py)
    add_ompl_python_test(geometric/test_geometric.py)
    add_ompl_python_test(geometric/test_geometric_compoundstate.py)
    add_ompl_python_test(control/test_control.py)

    # test the python function to boost::function conversion utility functions
    include_directories(${PYTHON_INCLUDE_DIRS})
    add_library(py_boost_function MODULE util/test_py_boost_function.cpp)
    target_link_libraries(py_boost_function ompl ${Boost_PYTHON_LIBRARY} ${PYTHON_LIBRARIES})
    if(WIN32)
        set_target_properties(py_boost_function PROPERTIES OUTPUT_NAME py_boost_function SUFFIX .pyd)
    endif(WIN32)
    add_custom_command(TARGET py_boost_function POST_BUILD
        COMMAND "${CMAKE_COMMAND}" -E copy "$<TARGET_FILE:py_boost_function>"
        "${CMAKE_CURRENT_SOURCE_DIR}/util"
        WORKING_DIRECTORY "${LIBRARY_OUTPUT_PATH}")
    add_ompl_python_test(util/test_py_boost_function.py)
endif()

add_subdirectory(regression_tests)

=== src/ompl/CMakeLists.txt ===
#############################################
# Construct configuration file              #
#############################################

file(TO_NATIVE_PATH "${CMAKE_CURRENT_SOURCE_DIR}" VERSION_DIR)
configure_file("${VERSION_DIR}/config.h.in" "${VERSION_DIR}/config.h")


#############################################
# recursively find all *.cpp files that     #
# correspond to the basic ompl library      #
#############################################
file(GLOB_RECURSE OMPL_SOURCE_CODE datastructures/*.cpp util/*.cpp base/*.cpp geometric/*.cpp control/*.cpp tools/*.cpp)



#############################################
# Add enabled extensions to the source code #
#############################################

## replace XXX by the extension
#if (OMPL_EXTENSION_XXX)
#    file(GLOB_RECURSE OMPL_XXX_EXTENSION_SOURCE_CODE extensions/XXX/*.cpp)
#    set(OMPL_SOURCE_CODE ${OMPL_SOURCE_CODE} ${OMPL_XXX_EXTENSION_SOURCE_CODE})
#
##    if additional libraries need to be linked, they are added to manifest.xml for ROS
##    or they are added to the list of OMPL_LINK_LIBRARIES
#
#endif()

if (OMPL_EXTENSION_MORSE)
    file(GLOB_RECURSE OMPL_MORSE_EXTENSION_SOURCE_CODE extensions/morse/*.cpp)
    set(OMPL_SOURCE_CODE ${OMPL_SOURCE_CODE} ${OMPL_MORSE_EXTENSION_SOURCE_CODE})
endif()

if (OMPL_EXTENSION_OPENDE)
    file(GLOB_RECURSE OMPL_OPENDE_EXTENSION_SOURCE_CODE extensions/opende/*.cpp)
    set(OMPL_SOURCE_CODE ${OMPL_SOURCE_CODE} ${OMPL_OPENDE_EXTENSION_SOURCE_CODE})
    list(APPEND OMPL_LINK_LIBRARIES "${OPENDE_LIBRARY}")
endif()

if (OMPL_EXTENSION_TRIANGLE)
  file(GLOB_RECURSE OMPL_TRIANGLE_EXTENSION_SOURCE_CODE extensions/triangle/*.cpp)
  set(OMPL_SOURCE_CODE ${OMPL_SOURCE_CODE} ${OMPL_TRIANGLE_EXTENSION_SOURCE_CODE})
  list(APPEND OMPL_LINK_LIBRARIES ${TRIANGLE_LIBRARY})
endif()

#############################################
# Build and install the library             #
#############################################
if(MSVC OR IS_ICPC)
  add_library(ompl STATIC ${OMPL_SOURCE_CODE})
else(MSVC OR IS_ICPC)
  add_library(ompl SHARED ${OMPL_SOURCE_CODE})
endif(MSVC OR IS_ICPC)
target_link_libraries(ompl
  ${OMPL_LINK_LIBRARIES}
  ${Boost_DATE_TIME_LIBRARY}
  ${Boost_THREAD_LIBRARY}
  ${Boost_SERIALIZATION_LIBRARY}
  ${Boost_FILESYSTEM_LIBRARY}
  ${Boost_SYSTEM_LIBRARY}
  ${Boost_CHRONO_LIBRARY}
  ${CMAKE_THREAD_LIBS_INIT})

if(MSVC)
  set_target_properties(ompl PROPERTIES VERSION "${OMPL_VERSION}" STATIC_LIBRARY_FLAGS "psapi.lib ws2_32.lib")
else(MSVC)
  if (MINGW)
    target_link_libraries(ompl psapi ws2_32)
    set_target_properties(ompl PROPERTIES LINK_FLAGS "-Wl,--export-all-symbols")
  endif(MINGW)
  set_target_properties(ompl PROPERTIES VERSION "${OMPL_VERSION}" SOVERSION "${OMPL_ABI_VERSION}")
endif(MSVC)

# install the library
install(TARGETS ompl
    DESTINATION ${CMAKE_INSTALL_LIBDIR}
    COMPONENT ompl)
if(NOT MSVC)
    add_custom_command(TARGET ompl POST_BUILD
        COMMAND "${CMAKE_COMMAND}" -E copy "$<TARGET_FILE:ompl>"
        "${CMAKE_CURRENT_SOURCE_DIR}/../../py-bindings/ompl/util/libompl${CMAKE_SHARED_LIBRARY_SUFFIX}"
        WORKING_DIRECTORY "${LIBRARY_OUTPUT_PATH}")
endif(NOT MSVC)

=== tests/regression_tests/CMakeLists.txt ===
add_executable(regression_test RegressionTest.cpp)
target_link_libraries(regression_test
    ompl
    ${Boost_FILESYSTEM_LIBRARY}
    ${Boost_SYSTEM_LIBRARY}
    ${Boost_THREAD_LIBRARY}
    ${Boost_DATE_TIME_LIBRARY})

=== debian/changelog ===
ompl (1.0.0+ds2-1build1) xenial; urgency=medium

  * No-change rebuild against new libode.

 -- Iain Lane <iain@orangesquash.org.uk>  Thu, 12 Nov 2015 12:37:44 +0000

ompl (1.0.0+ds2-1) unstable; urgency=medium

   * New upstream version.
   * Changed suffix from dfsg to ds.
   * Dropped jquery, jquery.powertip and bootstrap js files.
   * Built against the new version of boost. No FTBFS. (Closes: #799819).
   * Enabled Multiarch metadata
   * Improved copyright file

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Mon, 19 Oct 2015 17:30:42 +0200

=== debian/control ===
Source: ompl
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Leopold Palomo-Avellaneda <leo@alaxarxa.net>
Section: libs
Priority: optional
Build-Depends: debhelper (>= 9),
               cmake,
               dh-exec,
               libboost-date-time-dev (>= 1.50.0),
               libboost-thread-dev (>= 1.50.0),
               libboost-serialization-dev (>= 1.50.0),
               libboost-filesystem-dev (>= 1.50.0),
               libboost-system-dev (>= 1.50.0),
               libboost-program-options-dev (>= 1.50.0),
               libboost-test-dev (>= 1.50.0),
               libode-dev,
               libflann-dev (>= 1.8.3)
Standards-Version: 3.9.6
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/ompl.git
Vcs-Git: git://anonscm.debian.org/debian-science/packages/ompl.git
Homepage: http://ompl.kavrakilab.org

Package: libompl-dev
Multi-Arch: same
Architecture: any
Section: libdevel
Depends: libompl10 (= ${binary:Version}),
         pkg-config,
         ${misc:Depends},
         libboost-dev
Suggests: libode-dev
Conflicts: libompl-dev
Description: Open Motion Planning Library (OMPL) development files
 The Open Motion Planning Library is a set of sampling-based motion
 planning algorithms. The content of the library is limited to these
 algorithms, which means there is no environment specification, no
 collision detection, and no visualization. The library is designed so
 it can be easily integrated into systems that provide those
 additional components. This package contains the development files
 needed to use the library.

Package: libompl10
Multi-Arch: same
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Open Motion Planning Library (OMPL)
 The Open Motion Planning Library is a set of sampling-based motion
 planning algorithms. The content of the library is limited to these
 algorithms, which means there is no environment specification, no
 collision detection, and no visualization. The library is designed so
 it can be easily integrated into systems that provide those
 additional components.  This package contains the library itself.

Package: ompl-demos
Multi-Arch: foreign
Architecture: all
Section: science
Depends: ${misc:Depends},
         python,
         python-matplotlib,
         libompl-dev
Conflicts: ompl-demos
Description: Open Motion Planning Library (OMPL) demos
 The Open Motion Planning Library is a set of sampling-based motion
 planning algorithms. The content of the library is limited to these
 algorithms, which means there is no environment specification, no
 collision detection or visualization. The library is designed so it
 can be easily integrated into systems that provide the additional
 needed components.  This package contains a set of demos of the
 library.

Package: libompl10-dbg
Multi-Arch: same
Architecture: any
Section: debug
Priority: extra
Depends: ${misc:Depends},
         libompl10 (= ${binary:Version}),
         libompl-dev
Description: Open Motion Planning Library (OMPL) debug symbols
 The Open Motion Planning Library is a set of sampling-based motion
 planning algorithms. The content of the library is limited to these
 algorithms, which means there is no environment specification, no
 collision detection or visualization. The library is designed so it
 can be easily integrated into systems that provide the additional
 needed components.  This package contains the debug symbols for the
 library.

=== debian/rules ===
#!/usr/bin/make -f

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)  
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_BUILD_OPTIONS += nocheck

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
endif

# These don't need to be exported and if they are we'll get the flags
# duplicated in the command line.
#unexport CFLAGS  
#unexport CXXFLAGS
#unexport LDFLAGS

CMAKE_FLAGS = \
        -DCMAKE_INSTALL_PREFIX=/usr \
        -DCMAKE_LIBRARY_ARCHITECTURE="$(DEB_HOST_MULTIARCH)" \
        -DCMAKE_VERBOSE_MAKEFILE=ON \
        -DCMAKE_C_FLAGS_RELEASE="$(CFLAGS)" \
        -DCMAKE_CXX_FLAGS_RELEASE="$(CXXFLAGS)" \
        -DCMAKE_SHARED_LINKER_FLAGS_RELEASE="$(LDFLAGS)" \
        -DCMAKE_BUILD_TYPE=RelWithDebInfo \
	-DCMAKE_SKIP_INSTALL_RPATH=TRUE \
	-DOMPL_ODESOLVER=ON \
        -DOMPL_REGISTRATION=OFF \
	-DOMPL_BUILD_PYBINDINGS=ON \
	-DOMPL_BUILD_PYTESTS=OFF

%:
	dh $@ --builddirectory=build --buildsystem=cmake --parallel

override_dh_clean:
	rm -rf build
	rm -rf CMakeModules/ompl.pc
	rm -rf py-bindings/ompl/bindings_generator.py*
	rm -rf py-bindings/ompl/__init__.pyc
	rm -rf .registered
	rm -rf src/ompl/config.h
	rm -rf tests/resources/config.h
#	rm -rf doc/markdown/api_overview.md  
	rm -rf doc/markdown/download.md
	rm -rf doc/markdown/mainpage.md
	rm -rf tests/BoostTestTeamCityReporter.h

	find py-bindings/ -name *.pypp.*  | xargs -n1 rm -rf
	find py-bindings/ -name *.pyc  | xargs -n1 rm -rf
	find py-bindings/ -name *.so  | xargs -n1 rm -rf 
	dh_clean


override_dh_auto_configure:
	mkdir -p build 
	dh_auto_configure --builddirectory=build -- $(CMAKE_FLAGS) $(CMAKE_ARCH_FLAGS) 

override_dh_auto_build:
# Uncomment this part to prepare the python bindings
#	cd build && $(MAKE) update_bindings
	cd build && $(MAKE) 

override_dh_auto_install:
	dh_auto_install --builddirectory=build

override_dh_install:
	mkdir -p debian/tmp/usr/share/doc/libompl10-dbg && cp debian/README.Debug debian/tmp/usr/share/doc/libompl10-dbg/

	dh_install --list-missing

override_dh_auto_test:
	echo "Supressing upstream tests"

override_dh_strip:
	dh_strip --dbg-package=libompl10-dbg

=== debian/watch ===
# Watch control file for uscan
# Compulsory line, this is a version 3 file
version=3
#opts=dversionmangle=s/\.dfsg// \
opts=dversionmangle=s/\+ds1\d?$//,repacksuffix=+ds1 \
 https://bitbucket.org/ompl/ompl/downloads/ompl-(.*)\-Source.tar.gz

## ompl 1.1.0%2Bds1

=== py-bindings/CMakeLists.txt ===
option(OMPL_BUILD_PYBINDINGS "Build OMPL Python bindings" ON)
option(OMPL_BUILD_PYTESTS "Build OMPL Python tests" ON)

if (OMPL_BUILD_PYBINDINGS)

    include(PythonBindingsUtils)

    if(WIN32)
        # omit StateStorage class bindings on Windows;
        # Boost.Serialization does nasty things that break the bindings.
        set(PYOMPL_EXTRA_CFLAGS "${PYOMPL_EXTRA_CFLAGS} -DOMPL_BASE_STATE_STORAGE_ -DOMPL_BASE_PLANNER_DATA_STORAGE_ -DOMPL_CONTROL_PLANNER_DATA_STORAGE_")
        add_definitions(-DOMPL_BASE_STATE_STORAGE_ -DOMPL_BASE_PLANNER_DATA_STORAGE_ -DOMPL_CONTROL_PLANNER_DATA_STORAGE_)
    endif(WIN32)

    set(OMPL_MODULES base control geometric tools util)
    if(OMPL_EXTENSION_MORSE)
        list(APPEND OMPL_MODULES morse)
    endif()

    if(PY_OMPL_GENERATE)
        # need to run cmake to regenerate ompl/bindings_generator.py if
        # bindings_generator.py.in is changed.
        configure_file("${CMAKE_CURRENT_SOURCE_DIR}/bindings_generator.py.in"
            "${CMAKE_CURRENT_SOURCE_DIR}/ompl/bindings_generator.py" @ONLY)

        create_module_generation_targets(util "${CMAKE_CURRENT_SOURCE_DIR}")
        if(OMPL_HAVE_EIGEN3)
            create_module_generation_targets(base "${CMAKE_CURRENT_SOURCE_DIR}")
            create_module_generation_targets(geometric "${CMAKE_CURRENT_SOURCE_DIR}")
        else()
            create_module_generation_targets(base "${CMAKE_CURRENT_SOURCE_DIR}" PathLengthDirectInfSampler)
            create_module_generation_targets(geometric "${CMAKE_CURRENT_SOURCE_DIR}" bitstar)
        endif()
        create_module_generation_targets(control "${CMAKE_CURRENT_SOURCE_DIR}")
        create_module_generation_targets(tools "${CMAKE_CURRENT_SOURCE_DIR}")
        if(OMPL_EXTENSION_MORSE)
            create_module_generation_targets(morse "${CMAKE_CURRENT_SOURCE_DIR}")
        endif()

        add_dependencies(update_base_bindings update_util_bindings)
        add_dependencies(update_geometric_bindings update_base_bindings)
        add_dependencies(update_control_bindings update_geometric_bindings)
        add_dependencies(update_control_bindings update_base_bindings)
        add_dependencies(update_tools_bindings update_control_bindings)
        if(OMPL_EXTENSION_MORSE)
            add_dependencies(update_morse_bindings update_base_bindings)
            add_dependencies(update_morse_bindings update_control_bindings)
        endif()
    endif(PY_OMPL_GENERATE)

    if(PY_OMPL_COMPILE AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/bindings")
        foreach(module ${OMPL_MODULES})
            create_module_target(${module} "${CMAKE_CURRENT_SOURCE_DIR}")
        endforeach(module)

        install(DIRECTORY ompl DESTINATION "${OMPL_PYTHON_INSTALL_DIR}"
            COMPONENT python
            PATTERN "*.pyc" EXCLUDE
            PATTERN "__pycache__" EXCLUDE
            PATTERN "_*.so" EXCLUDE
            PATTERN "app" EXCLUDE
            PATTERN "morse" EXCLUDE)
        # put app submodule in omplapp component
        if(OMPLAPP_VERSION)
            install(DIRECTORY ompl/app
                DESTINATION "${OMPL_PYTHON_INSTALL_DIR}/ompl"
                COMPONENT omplapp
                PATTERN "*.pyc" EXCLUDE
                PATTERN "__pycache__" EXCLUDE
                PATTERN "_*.so" EXCLUDE)
        endif()
        # put morse submodule in morse component
        if(OMPL_EXTENSION_MORSE)
            install(DIRECTORY ompl/morse
                DESTINATION "${OMPL_PYTHON_INSTALL_DIR}/ompl"
                COMPONENT morse
                PATTERN "*.pyc" EXCLUDE
                PATTERN "__pycache__" EXCLUDE
                PATTERN "_*.so" EXCLUDE
                PATTERN "addons" EXCLUDE)
            # blender add-on
            install(DIRECTORY ompl/morse/addons
                DESTINATION "share/ompl${OMPL_INSTALL_SUFFIX}"
                COMPONENT morse
                PATTERN "*.pyc" EXCLUDE)
        endif()
    endif()

endif(OMPL_BUILD_PYBINDINGS)

add_custom_target(clean_bindings
    "${CMAKE_COMMAND}" -E remove_directory "${CMAKE_CURRENT_SOURCE_DIR}/bindings"
    COMMAND "${CMAKE_COMMAND}" -E remove -f pyplusplus_{base,control,geometric,tools,util}.{cache,log}
    WORKING_DIRECTORY "${PROJECT_BINARY_DIR}")

=== debian/changelog ===
ompl (1.1.0+ds1-2) unstable; urgency=medium

  * Added flann patches
  * Bump Standards-Version to 3.9.8 (no changes)
  * Added pkg-config as build dependency
  * Flann patches added to series
  * Added DEB_CXXFLAGS_MAINT_APPEND to rules to compile with 
    gcc-6. Thanks Adrian Bunk (Closes: #831074)
  * Added hardening=+bindnow to DEB_BUILD_MAINT_OPTIONS

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Tue, 30 Aug 2016 12:03:54 +0200

ompl (1.1.0+ds1-1) unstable; urgency=medium

  * New upstream version.
  * Bump Standards-Version to 3.9.7 (no changes)
  * Updated Vcs-Browser and Vcs-Git fields
  * Updated patches
  * Fixed soname change
  * Fixing filename and description
  * Some clean statements in rules

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Wed, 27 Apr 2016 08:25:42 +0200

=== debian/control ===
--- 
+++ 
@@ -14,17 +14,18 @@
                libboost-program-options-dev (>= 1.50.0),
                libboost-test-dev (>= 1.50.0),
                libode-dev,
+	       pkg-config,
                libflann-dev (>= 1.8.3)
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/ompl.git
-Vcs-Git: git://anonscm.debian.org/debian-science/packages/ompl.git
+Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/ompl.git
 Homepage: http://ompl.kavrakilab.org
 
 Package: libompl-dev
 Multi-Arch: same
 Architecture: any
 Section: libdevel
-Depends: libompl10 (= ${binary:Version}),
+Depends: libompl11 (= ${binary:Version}),
          pkg-config,
          ${misc:Depends},
          libboost-dev
@@ -39,7 +40,7 @@
  additional components. This package contains the development files
  needed to use the library.
 
-Package: libompl10
+Package: libompl11
 Multi-Arch: same
 Architecture: any
 Depends: ${shlibs:Depends},
@@ -70,13 +71,13 @@
  needed components.  This package contains a set of demos of the
  library.
 
-Package: libompl10-dbg
+Package: libompl11-dbg
 Multi-Arch: same
 Architecture: any
 Section: debug
 Priority: extra
 Depends: ${misc:Depends},
-         libompl10 (= ${binary:Version}),
+         libompl11 (= ${binary:Version}),
          libompl-dev
 Description: Open Motion Planning Library (OMPL) debug symbols
  The Open Motion Planning Library is a set of sampling-based motion

=== debian/rules ===
--- 
+++ 
@@ -8,6 +8,8 @@
 DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 DEB_BUILD_OPTIONS += nocheck
+export DEB_CXXFLAGS_MAINT_APPEND = -std=gnu++98
+export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
 
 ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
 	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
@@ -38,14 +40,16 @@
 	dh $@ --builddirectory=build --buildsystem=cmake --parallel
 
 override_dh_clean:
+ifneq ("$(wildcard $(build/bindings_generator.py))","")
+	rm -rf py-bindings/ompl/bindings_generator.py*
+	mv build/bindings_generator.py py-bindings/ompl/
+endif
 	rm -rf build
 	rm -rf CMakeModules/ompl.pc
-	rm -rf py-bindings/ompl/bindings_generator.py*
 	rm -rf py-bindings/ompl/__init__.pyc
 	rm -rf .registered
 	rm -rf src/ompl/config.h
 	rm -rf tests/resources/config.h
-#	rm -rf doc/markdown/api_overview.md  
 	rm -rf doc/markdown/download.md
 	rm -rf doc/markdown/mainpage.md
 	rm -rf tests/BoostTestTeamCityReporter.h
@@ -69,7 +73,7 @@
 	dh_auto_install --builddirectory=build
 
 override_dh_install:
-	mkdir -p debian/tmp/usr/share/doc/libompl10-dbg && cp debian/README.Debug debian/tmp/usr/share/doc/libompl10-dbg/
+	mkdir -p debian/tmp/usr/share/doc/libompl11-dbg && cp debian/README.Debug debian/tmp/usr/share/doc/libompl11-dbg/
 
 	dh_install --list-missing
 
@@ -77,7 +81,7 @@
 	echo "Supressing upstream tests"
 
 override_dh_strip:
-	dh_strip --dbg-package=libompl10-dbg
+	dh_strip --dbg-package=libompl11-dbg

## ompl 1.1.0+ds1

=== CMakeLists.txt ===
--- 
+++ 
@@ -108,6 +108,13 @@
 find_package(Python QUIET)
 find_package(Boost COMPONENTS python QUIET)
 
+# Eigen is needed for the InformedStateSampler
+find_package(Eigen3 QUIET)
+if (EIGEN3_FOUND)
+    set(OMPL_HAVE_EIGEN3 1)
+    include_directories("${EIGEN3_INCLUDE_DIRS}")
+endif()
+
 # MORSE is only needed for Modular OpenRobots Simulation Engine bindings
 find_package(MORSE QUIET)
 set(OMPL_EXTENSION_MORSE ${MORSE_FOUND})
@@ -132,6 +139,9 @@
     set(OMPL_HAVE_FLANN 1)
     include_directories(SYSTEM "${FLANN_INCLUDE_DIRS}")
 endif()
+
+# R is needed for running Planner Arena locally
+find_program(R_EXEC R)
 
 option(OMPL_LOCAL_PYPLUSPLUS_INSTALL "Whether Py++ and dependencies should be installed in the build directory" OFF)
 set(SUDO "sudo")
@@ -150,9 +160,10 @@
 add_subdirectory(doc)
 
 if (NOT MSVC)
+  target_link_flags(ompl)
   set(PKG_NAME "ompl")
   set(PKG_DESC "The Open Motion Planning Library")
-  set(PKG_OMPL_LIBS "-lompl")
+  set(PKG_OMPL_LIBS "-lompl ${ompl_LINK_FLAGS}")
   set(pkg_conf_file "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules/ompl.pc")
   configure_file("${pkg_conf_file}.in" "${pkg_conf_file}" @ONLY)
   install(FILES "${pkg_conf_file}"
@@ -164,6 +175,10 @@
     DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/ompl${OMPL_INSTALL_SUFFIX}"
     COMPONENT ompl
     RENAME ompl-config.cmake)
+
+  install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/ompl.conf"
+    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/ompl${OMPL_INSTALL_SUFFIX}"
+    COMPONENT ompl)
 endif()
 
 # uninstall target

=== demos/CMakeLists.txt ===
--- 
+++ 
@@ -27,6 +27,7 @@
   aux_source_directory(Koules Koules_SRC)
   add_ompl_demo(demo_Koules ${Koules_SRC})
   add_ompl_demo(demo_PlannerData PlannerData.cpp)
+  add_ompl_demo(demo_ThunderLightning ThunderLightning.cpp)
 
   add_ompl_demo(demo_OptimalPlanning OptimalPlanning.cpp)
   add_ompl_demo(demo_PlannerProgressProperties PlannerProgressProperties.cpp)

=== src/ompl/CMakeLists.txt ===
--- 
+++ 
@@ -12,7 +12,11 @@
 #############################################
 file(GLOB_RECURSE OMPL_SOURCE_CODE datastructures/*.cpp util/*.cpp base/*.cpp geometric/*.cpp control/*.cpp tools/*.cpp)
 
-
+if(NOT OMPL_HAVE_EIGEN3)
+    list(REMOVE_ITEM OMPL_SOURCE_CODE
+        "${CMAKE_CURRENT_SOURCE_DIR}/util/src/ProlateHyperspheroid.cpp"
+        "${CMAKE_CURRENT_SOURCE_DIR}/base/samplers/informed/src/PathLengthDirectInfSampler.cpp")
+endif()
 
 #############################################
 # Add enabled extensions to the source code #

=== debian/changelog ===
ompl (1.1.0+ds1-1b1) staging; urgency=high

  * No-change rebuild against libode6

 -- Philip Muškovac <yofel@kubuntu.org>  Wed, 15 Jun 2016 12:11:19 +0000

=== debian/control ===
--- 
+++ 
@@ -14,9 +14,8 @@
                libboost-program-options-dev (>= 1.50.0),
                libboost-test-dev (>= 1.50.0),
                libode-dev,
-	       pkg-config,
                libflann-dev (>= 1.8.3)
-Standards-Version: 3.9.8
+Standards-Version: 3.9.7
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/ompl.git
 Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/ompl.git
 Homepage: http://ompl.kavrakilab.org

=== debian/rules ===
--- 
+++ 
@@ -8,8 +8,6 @@
 DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 DEB_BUILD_OPTIONS += nocheck
-export DEB_CXXFLAGS_MAINT_APPEND = -std=gnu++98
-export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
 
 ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
 	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))

## ompl 1.2.1%2Bds1

=== doc/CMakeLists.txt ===
--- 
+++ 
@@ -14,8 +14,12 @@
     configure_file("${CMAKE_CURRENT_SOURCE_DIR}/markdown/mainpage.md.in"
         "${CMAKE_CURRENT_SOURCE_DIR}/markdown/mainpage.md")
     file(READ "${CMAKE_CURRENT_SOURCE_DIR}/images/ompl.svg" OMPLSVG)
+    file(READ "${CMAKE_CURRENT_SOURCE_DIR}/images/cforest.svg" CFORESTSVG)
+    file(READ "${CMAKE_CURRENT_SOURCE_DIR}/images/cforest_sampler.svg" CFOREST_SAMPLERSVG)
     configure_file("${CMAKE_CURRENT_SOURCE_DIR}/markdown/api_overview.md.in"
         "${CMAKE_CURRENT_SOURCE_DIR}/markdown/api_overview.md")
+    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/markdown/CForest.md.in"
+        "${CMAKE_CURRENT_SOURCE_DIR}/markdown/CForest.md")
 
     # add "doc" target if Doxygen is detected
     add_custom_target(doc
@@ -29,5 +33,5 @@
         WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/doc")
 endif(DOXYGEN)
 
-install(FILES man/ompl_benchmark_statistics.1
+install(FILES man/ompl_benchmark_statistics.1 man/plannerarena.1
     DESTINATION ${CMAKE_INSTALL_MANDIR}/man1 COMPONENT ompl)

=== py-bindings/CMakeLists.txt ===
--- 
+++ 
@@ -23,18 +23,18 @@
         configure_file("${CMAKE_CURRENT_SOURCE_DIR}/bindings_generator.py.in"
             "${CMAKE_CURRENT_SOURCE_DIR}/ompl/bindings_generator.py" @ONLY)
 
-        create_module_generation_targets(util "${CMAKE_CURRENT_SOURCE_DIR}")
+        create_module_generation_targets(util)
         if(OMPL_HAVE_EIGEN3)
-            create_module_generation_targets(base "${CMAKE_CURRENT_SOURCE_DIR}")
-            create_module_generation_targets(geometric "${CMAKE_CURRENT_SOURCE_DIR}")
+            create_module_generation_targets(base)
+            create_module_generation_targets(geometric)
         else()
-            create_module_generation_targets(base "${CMAKE_CURRENT_SOURCE_DIR}" PathLengthDirectInfSampler)
-            create_module_generation_targets(geometric "${CMAKE_CURRENT_SOURCE_DIR}" bitstar)
+            create_module_generation_targets(base PathLengthDirectInfSampler)
+            create_module_generation_targets(geometric bitstar)
         endif()
-        create_module_generation_targets(control "${CMAKE_CURRENT_SOURCE_DIR}")
-        create_module_generation_targets(tools "${CMAKE_CURRENT_SOURCE_DIR}")
+        create_module_generation_targets(control)
+        create_module_generation_targets(tools)
         if(OMPL_EXTENSION_MORSE)
-            create_module_generation_targets(morse "${CMAKE_CURRENT_SOURCE_DIR}")
+            create_module_generation_targets(morse)
         endif()
 
         add_dependencies(update_base_bindings update_util_bindings)
@@ -48,9 +48,9 @@
         endif()
     endif(PY_OMPL_GENERATE)
 
-    if(PY_OMPL_COMPILE AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/bindings")
+    if(PY_OMPL_COMPILE AND EXISTS "${CMAKE_CURRENT_BINARY_DIR}/bindings")
         foreach(module ${OMPL_MODULES})
-            create_module_target(${module} "${CMAKE_CURRENT_SOURCE_DIR}")
+            create_module_target(${module})
         endforeach(module)
 
         install(DIRECTORY ompl DESTINATION "${OMPL_PYTHON_INSTALL_DIR}"
@@ -89,6 +89,6 @@
 endif(OMPL_BUILD_PYBINDINGS)
 
 add_custom_target(clean_bindings
-    "${CMAKE_COMMAND}" -E remove_directory "${CMAKE_CURRENT_SOURCE_DIR}/bindings"
+    "${CMAKE_COMMAND}" -E remove_directory "${CMAKE_CURRENT_BINARY_DIR}/bindings"
     COMMAND "${CMAKE_COMMAND}" -E remove -f pyplusplus_{base,control,geometric,tools,util}.{cache,log}
     WORKING_DIRECTORY "${PROJECT_BINARY_DIR}")
